
Flock flock;
int nBoids = 256*2;

float Kcoh = 1.25;
float sepDist = 15.0;
float predDist = 80.0;

final int RENDER_WIREFRAME = 1001;
final int RENDER_ELIPSOID  = 1002;
final int RENDER_CLOUD     = 1003;
int renderMode = RENDER_ELIPSOID;
boolean renderBoid = false;

float[][] density;
int step = 8;

PImage boidMask;
PImage boidImg;
PImage bkgrnd;

void setup() {
  size(640, 480, P3D);
  flock = new Flock();
  // Add an initial set of boids into the system
  for (int i = 0; i < nBoids; i++) {
    float th = random(0,TWO_PI);
    float ra = random(0,128);
    float rx = ra*cos(th)+width/2;
    float ry = ra*sin(th)+height/2;
    flock.addBoid(new Boid(rx,ry));
  }
  for (int i = 0; i < 0; i++) {
    flock.addBoid(new Predator(new PVector(random(-64,64),random(-64,64)), 4.0, 0.03));
  }
  ellipseMode(RADIUS);
  density = new float[width/step][];
  for( int x = 0; x < width/step; x ++ ) {
    density[x] = new float[height/step];
  }
  boidMask = loadImage("texture.gif");
  boidImg  = new PImage(boidMask.width, boidMask.height);
  for (int i = 0; i < boidImg.pixels.length; i++) boidImg.pixels[i] = color(255);
  boidImg.mask(boidMask);
  imageMode(CENTER);
  bkgrnd = loadImage("fallcolor3.jpg");
  bkgrnd.loadPixels();
}

void draw() {
  if( !mousePressed ) {
    Kcoh = 1.15+0.25*sin(frameCount/100.0);
  } else {
    if( mouseButton == LEFT ) {
      Kcoh = 0.5;
    } else {
      Kcoh = -1.0;
    }
  }
  background(0);
  
  
  int n = 0;
  pushStyle();
  noStroke();
  int range = 5;
  for( int x = 0; x < width/step; x ++ ) {
    for( int y = 0; y < height/step; y ++ ) {
      density[x][y] = flock.count((x-range)*step, (x+1+range)*step, (y-range)*step, (y+1+range)*step);
      density[x][y] = map(density[x][y], 0, 164, 0, 255);
    }
  }
  for( int x = 0; x < width/step-1; x ++ ) {
    for( int y = 0; y < height/step-1; y ++ ) {
      /*
      //stroke(0,200,0);
      fill(0,32,0);
      beginShape(QUADS);
      fill( density[x][y] );
      vertex(x*step, y*step);
      fill( density[x+1][y] );
      vertex((x+1)*step, y*step);
      fill( density[x+1][y+1] );
      vertex((x+1)*step, (y+1)*step);
      fill( density[x][y+1] );
      vertex(x*step, (y+1)*step);
      endShape();
      */
      fill( 0, 0, density[x][y] );
      rect( x*step, y*step, step, step );
    }
  }
  popStyle();
  
  
  flock.run();
  text(nf(frameRate,2,1),10,20);
  text(nf(Kcoh,1,2),10,height-20);
}

// Add a new boid into the System
void mousePressed() {

}

void keyPressed() {
  if( key == 'r' ) {
    renderBoid = !renderBoid;
  } else if( key == 'w' ) {
    //wireframe = !wireframe;
    if( renderMode == RENDER_CLOUD ) {
      renderMode = RENDER_WIREFRAME;
    } else {
      renderMode++;
    }
  }
}
