class Predator extends Boid {
  Boid boidTarget = null;
  int nbSecondsTxt = second() + 2;
  boolean gotBoid = false;
  
  Predator(PVector l, float ms, float mf) {
    super(l, ms, mf);
  }
  void flock(ArrayList boids) {
    PVector sep = separate(boids);   // Separation
    PVector ali = align(boids);      // Alignment
    PVector coh = cohesion(boids);   // Cohesion
    // Arbitrarily weight these forces
    sep.mult(1.5);
    ali.mult(1.0);
    coh.mult(3.0);
    // Add the force vectors to acceleration
    acc.add(sep);
    acc.add(ali);
    acc.add(coh);
  }
  
  PVector cohesion (ArrayList boids) {
    float neighbordist = 100.0;
    float eatdist=15.0;
    PVector sum = new PVector(0,0);
    int count = 0;
    if (second() - nbSecondsTxt >= 2) {
      gotBoid = false;
    }
    for (int i = 0 ; i < boids.size(); i++) {
      Boid other = (Boid) boids.get(i);
      float d = loc.dist(other.loc);
      if (d > 0) {
        if (d < eatdist) {
          //boids.remove(other);
          nbSecondsTxt=second();
          gotBoid = true;
        } else if (d < neighbordist && other.equals(boidTarget)) {
          sum = other.loc;
          boidTarget = other;
          count++;
          break;
        }
      }
      
      if ((d > 0) && (d < neighbordist)) {
        sum = other.loc;
        count++;
        break;
      }
    }
    if (count > 0) {
      //return steer(sum,false);  // Steer towards the location
      return seek(sum);
    }
    return sum;
  }
  
  void render() {
    pushMatrix();
    if( renderMode == RENDER_WIREFRAME ) {
    // Draw a triangle rotated in the direction of velocity
      float theta = vel.heading2D() + PI/2;
      if (gotBoid) {
        fill(255, 100, 100, 200);
      } else {
        fill(200,100);
      }
      stroke(255,0,0);
      translate(loc.x,loc.y);
      rotate(theta);
      beginShape(TRIANGLES);
      vertex(0, -r*2);
      vertex(-r, r*4);
      vertex(r, r*4);
      endShape();
      noFill();
      ellipse(0,0,sepDist,sepDist);
      ellipse(0,0,predDist,predDist);
    } else if( renderMode == RENDER_CLOUD ) {
      float theta = vel.heading2D();
      translate(loc.x,loc.y);
      rotate(theta);
      //tint(255,64,64,64);
      //image(boidImg,0,0,boidImg.width*5.0,boidImg.height*5.0);
      tint(255,64,64,212);
      image(boidImg,0,0,boidImg.width*1.60,boidImg.height*1.20);
    } else {
      float theta = vel.heading2D();
      translate(loc.x,loc.y);
      rotate(theta);
      stroke(255,0,0);
      fill(255,0,0);
      ellipse(0, 0, 3, 2);
    }
    popMatrix();
  }
  
  void escapeSpeedUp(boolean predatorAround, PVector steer) {}

  boolean escapeVector(PVector diff, Boid other) {
    return false;
  }
}

